window.addEventListener("load", function () {dictionarySwitcher.init();}, false);

var dictionarySwitcher = { /*FOLD00*/
  currentDict: "",
  dictMenu: {},
  panel: null,
  rememberMenuitem: null,
  list: [],
  langToDict: {},
  tldToDict: {},
  countryToTld: { /*fold00*/
    de: ['at', 'ch'],
    at: ['de', 'ch'],
    ch: ['de', 'at'],
    us: ['uk', 'com', 'org', 'net', 'gov', 'edu', 'au'],
    gb: ['uk', 'com', 'org', 'net', 'gov', 'edu', 'au'],
    au: ['uk', 'com', 'org', 'net', 'gov', 'edu']
  },
	LOG: function(text) /*fold00*/
	{
	    var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
		.getService(Components.interfaces.nsIConsoleService);
	    consoleService.logStringMessage(String(text));
	},
  autoSucceeded: false,
  init: function () { /*fold00*/
    if (!gURLBar)
      gURLBar = document.getElementById("urlbar");
    this.l10n = document.getElementById("dictionary-switcher-l10n");
    this.rememberMenuitem = document.getElementById("dictionary-switcher-remember");
    this.menuseparator = document.getElementById("dictionary-switcher-menu").getElementsByTagName("menuseparator")[0];

    this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                   .getService(Components.interfaces.nsIPrefService)
                   .getBranch("spellchecker.")
                   .QueryInterface(Components.interfaces.nsIPrefBranch2);
    try {
      this.currentDict = this.prefs.getCharPref("dictionary");
    } catch (e) {}
	try{
    this.prefs.addObserver("", this, false);
	} catch(e){ alert(e); }

    var spellclass = "@mozilla.org/spellchecker/myspell;1";
    if ("@mozilla.org/spellchecker/hunspell;1" in Components.classes)
      spellclass = "@mozilla.org/spellchecker/hunspell;1";
    else if ("@mozilla.org/spellchecker/engine;1" in Components.classes)
      spellclass = "@mozilla.org/spellchecker/engine;1";
    var spellchecker = Components.classes[spellclass].getService(Components.interfaces.mozISpellCheckingEngine);
    spellchecker.getDictionaryList(this.list, {});
    this.list = this.list.value.toString().split(",");

    var menuitem = document.createElement("menuitem")
    var bundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
    var languageBundle = bundleService.createBundle("chrome://global/locale/languageNames.properties");
    var regionBundle = bundleService.createBundle("chrome://global/locale/regionNames.properties");
      menuitem.setAttribute("type", "radio");
      menuitem.setAttribute("name", "dictionary-switcher-dicts");
      menuitem.setAttribute("oncommand", "dictionarySwitcher.toggle(this.getAttribute('dict'))");
      for (var i=0; i < this.list.length; i++) {
        var dict = this.list[i];
        var code = dict.split(/-|_/);
        this.langToDict[code[0]] = dict;
        if (code[1]) {
          var id = code[1].toLowerCase();
          this.tldToDict[id] = dict;
          if (id in this.countryToTld) {
            this.countryToTld[id].forEach(function (tld) {
              if (!(tld in this.tldToDict))
                this.tldToDict[tld] = dict;
            }, this);
          }
        }

        var displayName;
        var isoStrArray = dict.split(/-|_/);
        if (isoStrArray[0]) {
          try {
            displayName = languageBundle.GetStringFromName(isoStrArray[0].toLowerCase());
          } catch (e) {}
          if (isoStrArray[1]) {
            try {
              displayName += " / " + regionBundle.GetStringFromName(isoStrArray[1].toLowerCase());
            } catch (e) {}
            if (isoStrArray[2])
              displayName += " (" + isoStrArray[2] + ")";
          }
        }

        menuitem = menuitem.cloneNode(true);
        menuitem.setAttribute("label", displayName || dict);
        menuitem.setAttribute("dict", dict);
        this.dictMenu[dict] = menuitem;
        this.menuseparator.parentNode.insertBefore(menuitem, this.menuseparator);
      }

    var obj = this;
      gURLBar.addEventListener("ValueChange", function () {
        //XXX bug 436717
        setTimeout(function () {
          obj.pageSwitch();
        }, 0);
      }, true);
      this._pageLoad = function (e) {
        obj.pageLoad(e);
      };
      this._keyPress = function (e) {
        obj.keyPress(e);
      };
      window.addEventListener("unload", function () {
        obj.prefs = null;
        obj._textarea = null;
      }, false);

    this.getAutoPref();
    this.getAsITypePref();

    this.hostToDict = Components.utils.evalInSandbox(
      this.prefs.getCharPref("hostToDict"),
      new Components.utils.Sandbox("about:blank"));
    this.updateUI();
  },
  observe: function (subject, topic, data) { /*fold00*/
    if (topic == "nsPref:changed") {
      switch (data) {
        case "dictionary":
          try {
            this.currentDict = this.prefs.getCharPref("dictionary");
          } catch(e) {
            this.currentDict = null;
          }
          this.updateUI();
          break;
        case "autoChangeDictionary":
          this.getAutoPref();
          if (this.auto)
            this.autoDetect(1,1);
          this.updateUI();
          break;
        case "detectDictionaryAsIType":
          this.getAsITypePref();
          break;
      }
    }
  },
  getAutoPref: function () { /*fold00*/
    this.auto = this.prefs.getBoolPref("autoChangeDictionary");
    if (this.auto) {
      document.getElementById("dictionary-switcher-auto").setAttribute("checked", "true");
      getBrowser().addEventListener("DOMContentLoaded", this._pageLoad, true);
    } else {
      document.getElementById("dictionary-switcher-auto").removeAttribute("checked");
      getBrowser().removeEventListener("DOMContentLoaded", this._pageLoad, true);
    }
  },
  getAsITypePref: function () { /*fold00*/
    this.asIType = this.prefs.getBoolPref("detectDictionaryAsIType");
    if (this.asIType) {
      document.getElementById("dictionary-switcher-as-i-type").setAttribute ("checked", "true");
      getBrowser().addEventListener("keypress", this._keyPress, true);
    } else {
      document.getElementById("dictionary-switcher-as-i-type").removeAttribute ("checked");
      getBrowser().removeEventListener("keypress", this._keyPress, true);
    }
  },
  canSpellCheck: function (node) { /*fold00*/
    return node &&
           (node instanceof Window || node instanceof HTMLHtmlElement ||
            (node instanceof HTMLTextAreaElement || (node instanceof HTMLInputElement && node.type != "password")) && !node.readOnly);
  },
  getEditor: function (node) { /*fold00*/
    if (node instanceof HTMLHtmlElement)
      node = node.ownerDocument.defaultView;
    if (node instanceof Window) {
      var session = node.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIEditingSession);
      if (session.windowIsEditable(node))
        return session.getEditorForWindow(node);
    } else if (!node.readOnly) {
      return node.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor;
    }
    return null;
  },
  keyPress: function (e) { /*fold00*/
    var node = e.originalTarget;
    if ((this.host && this.host in this.hostToDict) || !this.canSpellCheck(node))
      return;
    var text = node instanceof HTMLHtmlElement ? node.ownerDocument.body.textContent : node.value;
//nc-edit
try{
	var min_length = 30;  //minimum chars to get the required amount of words
	if (text.length < min_length){
		this._textarea = null; //reset if text is deleted or too small
		return;
    }
	if (!this._textarea || node != this._textarea){ //always try as long as necessary
			var rand = Math.floor(Math.random() * (text.length - min_length)); //try different random substrings to get the required minimum words
			text = text.substring(text.length-min_length-rand, text.length-rand-1).match(/\s\w+(?=[\s,;:!\?\.])/gm); //use something like \s\w+\s as Umlaute workaround and to dismiss by substring cutted words
//DEBUG
/*
			if(text)
	      		for (var i = 0; i < text.length; i++)
					dictionarySwitcher.LOG("Sample: "+text[i]);
*/
			if(!text || text.length < 4)//minimum 4 words
				return;
			for (var i = 0; i < text.length; i++)
				text[i]= text[i].replace(/[\s,;:!\?\.]/g,""); //cleanup spaces and marks
    }else
        return;
}catch(e){alert(e);return;}
//nc-edit-end
    this._textarea = node;
    var editor = this.getEditor(node);
    if (!editor)
      return;
    var sc = editor.getInlineSpellChecker ?
      editor.getInlineSpellChecker(true) :
      editor.inlineSpellChecker;
    if (!sc || !sc.spellChecker)
      return;
//nc-edit
    var initialDict = sc.spellChecker.GetCurrentDictionary(), dict = initialDict;
	var minMisspelled = Number.MAX_VALUE;
    var misspelled, oldMisspelled, newDict;
    do {
	      misspelled = 0;
	      for (var i = 0; i < text.length; i++)
		  {
	        if (sc.spellChecker.CheckCurrentWordNoSuggest(text[i]))
	          misspelled++;
//remove
//dictionarySwitcher.LOG("TEST: "+text[i]);
		  }
//remove
//dictionarySwitcher.LOG("MISSPELLED: "+misspelled);
		  if (misspelled < minMisspelled){
			newDict = dict;
			minMisspelled = misspelled;
		  }
	      dict = this.getNextInList(dict);
//remove
//dictionarySwitcher.LOG("Next dict: "+dict);
	      sc.spellChecker.SetCurrentDictionary(dict);
     } while (misspelled && dict != initialDict);
    if (newDict && newDict != initialDict) {
      this.toggle(newDict, true);
//remove
//dictionarySwitcher.LOG("Toggle dict: "+newDict);
    }
    else
      sc.spellChecker.SetCurrentDictionary(initialDict);
  },
//nc-edit-end
  tryRecheck: function () { /*fold00*/
    var fields = [document.commandDispatcher.focusedElement || document.commandDispatcher.focusedWindow]; // if a field is focused, recheck it
    if (!this.canSpellCheck(fields[0]))
      fields = getBrowser().selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document.getElementsByTagName("textarea"); // otherwise recheck all textareas
    for (var i = 0; i < fields.length; i++) {
      var editor = this.getEditor(fields[i]);
      if (editor) {
        var sc = editor.getInlineSpellChecker ?
          editor.getInlineSpellChecker(true) :
          editor.inlineSpellChecker;
        if (sc && sc.spellChecker) {
          sc.spellChecker.SetCurrentDictionary(this.currentDict);
          sc.spellCheckRange(null);
        }
      }
    }
  },
  setDict: function (dict, recheck) { /*fold00*/
    if (!dict)
      return false;
    if (this.currentDict != dict) {
      this.prefs.setCharPref("dictionary", this.currentDict = dict);
      if (recheck)
        this.tryRecheck();
    }
    return true;
  },
  pageLoad: function (e) { /*fold00*/
    this._textarea = null;
    if (e.originalTarget == getBrowser().selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document)
      this.autoDetect(0,1);
  },
  pageSwitch: function () { /*fold00*/
    this._textarea = null;
    this.getHost();
    var dict = this.hostToDict[this.host];
    if (dict)
      this.setDict(dict);
    else
      this.autoDetect(1,1);
    this.updateUI();
  },
  autoDetect: function (checkHost, checkDocLang) { /*fold00*/
    if (!this.auto)
      return;
    if (this.host && this.host in this.hostToDict)
      return;
    if (checkDocLang)
      this.autoSucceeded = this.autoDetectPerDocLang();
    if (this.host && checkHost && !this.autoSucceeded)
      this.autoSucceeded = this.autoDetectPerHost();
  },
  autoDetectPerHost: function () { /*fold00*/
    if (!this.host)
      return false;
    var tld = this.host.replace(/.*\./, "");
    return tld in this.tldToDict ?
           this.setDict(this.tldToDict[tld]) :
           false;
  },
  autoDetectPerDocLang: function () { /*fold00*/
    var root = getBrowser().selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document.documentElement;
    if (root) {
      var lang = root.getAttribute("lang") || root.getAttribute("xml:lang");
      if (lang) {
        var i = this.list.indexOf(lang);
        return this.setDict(i < 0 ?
          this.langToDict[lang.substr(0,2)] :
          this.list[i], true);
      }
    }
    return false;
  },
  updateUI: function () { /*fold00*/
    var saved = this.host in this.hostToDict;
    this.rememberMenuitem.setAttribute("checked", saved);
    if (this.dictMenu._last)
      this.dictMenu._last.removeAttribute("checked");
    this.dictMenu._last = this.dictMenu[ this.currentDict ];
    if (this.dictMenu._last)
      this.dictMenu._last.setAttribute("checked", true);
    this.panel = document.getElementById("dictionary-switcher");
    if (!this.panel) // Has been moved back to FX4 ToolBarPalette
      return;
    this.panel.label = (this.auto && this.autoSucceeded && !saved ? this.l10n.getString("autoDetected")+" " : "") + (this.currentDict || this.l10n.getString("noDict"));
    this.panel.setAttribute("saved", saved);
  },
  getNextInList: function (dict) { /*fold00*/
    var i = this.list.indexOf(dict) + 1;
    if (i >= this.list.length)
      i = 0;
    return this.list[i];
  },
  toggle: function (dict, dontSave) { /*fold00*/
    this.setDict(dict || this.getNextInList(this.currentDict), true);
    if (this.host && !dontSave) {
      this.hostToDict[this.host] = this.currentDict;
      this.syncHostList();
    }
  },
  toggleAuto: function () { /*fold00*/
    this.prefs.setBoolPref("autoChangeDictionary", !this.auto);
  },
  toggleAsIType: function () { /*fold00*/
    this.prefs.setBoolPref("detectDictionaryAsIType", !this.asIType);
  },
  toggleRemember: function () { /*fold00*/
    if (this.host) {
      if (this.rememberMenuitem.getAttribute("checked") == "true")
        this.hostToDict[this.host] = this.currentDict;
      else {
        delete this.hostToDict[this.host];
        this.autoDetect(1,1);
      }
      this.syncHostList();
    }
  },
  syncHostList: function () { /*fold00*/
    this.prefs.setCharPref("hostToDict", this.hostToDict.toSource());
    this.updateUI();
  },
  getHost: function () { /*fold00*/
    var url = gURLBar.value.match(/\/\/(.*?)\//);
    this.host = url ? url[1] : null;
  }
}; /*FOLD00*/
