var dictionarySwitcher = { /*FOLD00*/
  dictMenu: {},
  init: function () { /*FOLD01*/
    var Cc = Components.classes;
    var spellclass = "@mozilla.org/spellchecker/";
    if ("@mozilla.org/spellchecker/myspell;1" in Cc)
      spellclass += "myspell;1";
    else
      spellclass += "engine;1";
    Cc[spellclass]
      .getService(Components.interfaces.mozISpellCheckingEngine)
      .getDictionaryList(this.list = {}, {});
    this.list = this.list.value.toString().split(",");
    if (this.list.length <= 1)
      return;

    this.panel = document.getElementById("dictionary-switcher");

    var menu = document.getElementById("dictionary-switcher-menu");
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("type", "radio");
    menuitem.setAttribute("name", "dictionary-switcher-dicts");
    menuitem.setAttribute("oncommand", "dictionarySwitcher.toggle(this.label)");
    for (var i = 0; i < this.list.length; i++) {
      menuitem = menuitem.cloneNode(true);
      menuitem.setAttribute("label", this.list[i]);
      this.dictMenu[this.list[i]] = menuitem;
      menu.appendChild(menuitem);
    }

    this.prefService.addObserver("spellchecker.dictionary", this, false);
    this.prefService.addObserver("extensions.dictionary-switcher.autodetect", this, false);
    // XXX 1.8
    var self = this;
    this._eventListener = function (event) { self.handleEvent(event); };
    GetCurrentEditorElement().addEventListener("load", this._eventListener, true);
    GetMsgSubjectElement().addEventListener("input", this._eventListener, false);

    this.autodetect = this.prefService.getBoolPref("extensions.dictionary-switcher.autodetect");
    this.dict = this.prefService.getCharPref("spellchecker.dictionary");
    this.updateUI(false);
  },
  uninit: function () { /*fold01*/
    this.prefService.removeObserver("spellchecker.dictionary", this);
    gMsgCompose.editor.removeEditActionListener(this);
    GetCurrentEditorElement().removeEventListener("load", this._eventListener, true);
    GetMsgSubjectElement().removeEventListener("input", this._eventListener, false);
  },
  get prefService() { /*fold01*/
    delete this.prefService;
    return this.prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                         .getService(Components.interfaces.nsIPrefBranch2);
  },
  get scCompose() { /*fold01*/
    delete this.scCompose;
    return this.scCompose = gMsgCompose.editor.getInlineSpellChecker ?
                             gMsgCompose.editor.getInlineSpellChecker(true) :
                             gMsgCompose.editor.inlineSpellChecker;
  },
  get scSubject() { /*fold01*/
    var editor = GetMsgSubjectElement().editor;
    delete this.scSubject;
    return this.scSubject = editor.getInlineSpellChecker ?
                             editor.getInlineSpellChecker(true) :
                             editor.inlineSpellChecker;
  },
  updateUI: function (recheck) { /*fold01*/
    this.panel.label = this.dict;
    if (this.dictMenu._last)
      this.dictMenu._last.removeAttribute("checked");
    if (this.dictMenu._last = this.dictMenu[ this.dict ])
      this.dictMenu._last.setAttribute("checked", true);
    if (recheck) {
      this.scCompose.spellChecker.SetCurrentDictionary(this.dict);
      if ("InlineSpellCheckerUI" in window)
        this.scCompose.spellCheckRange(null);
      else {
        var doc = window.content.document;
        var range = doc.createRange();
        range.selectNodeContents(doc.body);
        this.scCompose.spellCheckRange(range);
      }
      if (document.getElementById("msgSubject").getAttribute("spellcheck"))
        this.scSubject.spellCheckRange(null);
    }
  },
  toggle: function (dict) { /*fold01*/
    this.dict = dict || this.getNextInList(this.dict);
    this.updateUI(true);
    this.prefService.setCharPref("spellchecker.dictionary", this.dict);
  },
  getNextInList: function (dict) { /*fold01*/
    var i = this.list.indexOf(dict) + 1;
    if (i >= this.list.length)
      i = 0;
    return this.list[i];
  },
  detectDictionary: function (inlineSpellChecker, text) { /*fold01*/
    text = text.split(/[^\w\x80-\x9F\xA2-\xA4\xC0-\xD6\xD8-\xF6\xF9-\xFF]+/i);
    var l = text.length;
    var maxMisspelled = Math.round(l / 4);
    var sc = inlineSpellChecker.spellChecker;
    var dict = this.dict;
    var oldDict = dict;
    var misspelled, minMisspelled, newDict;
    do {
      misspelled = 0;
      for (var i = 0; i < l; i++)
        if (sc.CheckCurrentWord(text[i]))
          misspelled++;
      if (!newDict || misspelled < minMisspelled) {
        newDict = dict;
        minMisspelled = misspelled;
      }
      dict = this.getNextInList(dict);
      sc.SetCurrentDictionary(dict);
    } while (misspelled > maxMisspelled && dict != oldDict);
    if (newDict)
      this.toggle(newDict);
  },

  /* nsIObserver */
  observe: function (subject, topic, data) { /*fold01*/
    if (topic == "nsPref:changed") {
      switch(data) {
        case "spellchecker.dictionary":
          var dict = this.prefService.getCharPref("spellchecker.dictionary");
          if (dict != this.dict) {
            this.dict = dict;
            this.updateUI(false);
          }
          break;
        case "extensions.dictionary-switcher.autodetect":
          this.autodetect = this.prefService.getBoolPref("extensions.dictionary-switcher.autodetect");
          break;
      }
    }
  },

  /* nsIDOMEventListener */
  handleEvent: function (event) { /*fold01*/
    switch (event.type) {
      case "input":
        if (this.autodetect) {
          var text = event.target.value;
          var l = text.length;
          if (l == 10 || l == 20)
            this.detectDictionary(this.scSubject, text);
        }
        break;
      case "load":
        gMsgCompose.editor.addEditActionListener(this);
        break;
    }
  },

  /* nsIEditActionListener */ /*fold01*/
  DidCreateNode: function(){},
  DidDeleteNode: function(){},
  DidDeleteSelection: function(){},
  DidDeleteText: function(){},
  DidInsertNode: function(){},
  DidInsertText: function(){},
  DidJoinNodes: function(){},
  DidSplitNode: function(){},
  WillCreateNode: function(){},
  WillDeleteNode: function(){},
  WillDeleteSelection: function(){},
  WillDeleteText: function(){},
  WillInsertNode: function(){},
  WillInsertText: function (textNode, offset, string) { /*fold01*/
    if (this.autodetect) {
      var l = textNode.length;
      if (l == 15 || l == 30)
        this.detectDictionary(this.scCompose, textNode.textContent);
    }
  },
  WillJoinNodes: function(){}, /*FOLD00*/
  WillSplitNode: function(){}
};

window.addEventListener("load", function () { /*fold00*/
  dictionarySwitcher.init();
}, false);

window.addEventListener("unload", function () { /*fold00*/
  dictionarySwitcher.uninit();
}, false);
